/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
// Includes for TCP communication and timer, also for variables
// To use the components of the dialog "clientDlg", include also that header file
#include "clientDlg.h"
#include <qsocket.h>
#include <qstring.h>
#include <qtextstream.h>
#include <qtimer.h>
#include <iostream>

using namespace std;
// Here are the objects to create a connection and for polling 
QSocket* client;
QTimer* output;
QTimer* input;
QTimer* counter;
// To connect to the Web-IO use this slot (function)
void clientDlg::onConnect()
{   // Create a new socket from our clientDlg objekt
    client = new QSocket(this);
    bool ok;
    // Wait here for the signal if the connection succeeds
    connect(client, SIGNAL(connected()), SLOT(connectDone()));
    connect(client, SIGNAL(error(int)), SLOT(connectError(int)));
    // If no Ip entered display a message, else check if an port has been entered. If everything is correctly entered, try to connect to
    // the Web-IO
    if(le_ip->text() == "")
	le_statusBar->setText("No IP entered!");
    else if(le_port->text() == "")
	le_statusBar->setText("No port entered!");
    else
	client->connectToHost(le_ip->text(), (le_port->text()).toInt(&ok,10));

}
// If the connection succeeds will be displayed a message, the receive-process begin, the timer for polling geht initialized and
// all important components get accessible
void clientDlg::connectDone()
{
    le_statusBar->setText("Connected to " + le_ip->text());
    connect(client, SIGNAL(readyRead()), SLOT(onReceive()));
    // One of the Timer for polling, we also connect this timer with the slot, which catch the periodic fired signal
    output = new QTimer(this);
    connect(output, SIGNAL(timeout()), SLOT(timerEvent()));
    
    input = new QTimer(this);
    connect(input, SIGNAL(timeout()), SLOT(timerEvent()));
    
    counter = new QTimer(this);
    connect(counter, SIGNAL(timeout()), SLOT(timerEvent()));
    // Enable and disable components
    gb_io_control->setEnabled(true);
    bt_disconnect->setEnabled(true);
    bt_connect->setEnabled(false);
}
// Will be called if a connection is not possible and display a message in the statusbar
void clientDlg::connectError( int )
{
    le_statusBar->setText("Error by connecting!");
}
// By disconnecting close the socket and stop every timer, which still can be active
void clientDlg::onDisconnect()
{
    client->close();
    
    output->stop();
    input->stop();
    counter->stop();
    // Set the state of the applicetion back to the beginning state
    gb_io_control->setEnabled(false);
    bt_disconnect->setEnabled(false);
    bt_connect->setEnabled(true);
    le_statusBar->setText("Disconnected!");
}
// This method will handle the receive process
void clientDlg::onReceive()
{   // Use a buffer for a received message from the Web-IO
    char buffer[50];
    client->readBlock(buffer, 49);
    QString rcv = buffer;
    bool ok;
    // Check if the message contains information about an output, input or an counter
    if(rcv[0] == 'o')
    {	// If the message includes the state of outputs change the gui (graphical user interface)
	int value = rcv.right(rcv.length()-7).toInt(&ok, 16);
	if((value & 1) == 1)	cb_output0->setChecked(true);
	else			cb_output0->setChecked(false);
	if((value & 2) == 2)	cb_output1->setChecked(true);
	else			cb_output1->setChecked(false);
    }
    if(rcv[0] == 'i')
    {	// Here we update the face of the application in relation to the state of inputs
	int value = rcv.right(rcv.length()-6).toInt(&ok, 16);
	if((value & 1) == 1)	cb_input0->setChecked(true);
	else			cb_input0->setChecked(false);
	if((value & 2) == 2)	cb_input1->setChecked(true);
	else			cb_input1->setChecked(false);
    }
    if(rcv[0] == 'c')
    {	// If the received message handle about the change of counter, update the counter in the gui or clear them 
	if(rcv[7] == '0')	le_counter0->setText(rcv.right(rcv.length()-9));
	if(rcv[7] == '1')	le_counter1->setText(rcv.right(rcv.length()-9));
	if(rcv[7] == ';')	readAndClearCounter(rcv.right(rcv.length()-8));	
    }
}
// If all counter get involved threw one command request, ubdate all counter in the gui
void clientDlg::readAndClearCounter(QString data)
{   // The received string comprised 12 counter states
    QString counter[12];
    int j = 0;
    int length = data.length();
    for(int i = 0; i < length; i++)
    {	// If the next char in the string is an semicolon, begin a new counter, because the last one ends here
	if(data[i] == ';')
	    j++;
	else	// else add this char to the curent counter in the array
	    counter[j] += data[i];
    } // Refresh the information in the gui
    le_counter0->setText(counter[0]);
    le_counter1->setText(counter[1]);
}
// To set the outputs we use this function
void clientDlg::onOutput0()
{    // Here are to different strings, which set or unset the output number 0
    QString message1 = "GET /outputaccess0?PW=" + le_password->text() + "&State=ON&";
    QString message2 = "GET /outputaccess0?PW=" + le_password->text() + "&State=OFF&";
    // If the checkbox is checked set the output, otherwise unset it, by sending the message over the network
    if(cb_output0->isChecked())	client->writeBlock(message1, message1.length());	
    else				client->writeBlock(message2, message2.length());
    // Clear the stream of waiting data
    client->flush();
}
// Here we set or unset the output number 1
void clientDlg::onOutput1()
{    // Also two strings for the commands, which will be send to the Web-IO
    QString message1 = "GET /outputaccess1?PW=" + le_password->text() + "&State=ON&";
    QString message2 = "GET /outputaccess1?PW=" + le_password->text() + "&State=OFF&";
    if(cb_output1->isChecked())	client->writeBlock(message1, message1.length());	
    else				client->writeBlock(message2, message2.length());
    client->flush();
}
// To check the state of the outputs
void clientDlg::onReadallOutputs()
{    // In every command string for the Web-IO, we check if a password has been entered
    QString message = "GET /output?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();
}
//  In this function we can check the state of the inputs, all with one command
void clientDlg::onReadallInputs()
{
    QString message = "GET /input?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();
}
// To read the state of the counter number 0 we use this method
void clientDlg::onReadCounter0()
{
    QString message = "GET /counter0?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();
}
// Also wen can read the state of the counter 1 
void clientDlg::onReadCounter1()
{
    QString message = "GET /counter1?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();
}
// If we want , its possible to read all counter in one way, also that counter we don´t use in our application
void clientDlg::onReadallCounter()
{
    QString message = "GET /counter?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();    
}
// If we can read a counter, its also possible to reset its state. We send a commando for reset of counter 0 in this method
void clientDlg::onClearCounter0()
{
    QString message = "GET /counterclear0?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();        
}
// Here we reset the counter 1
void clientDlg::onClearCounter1()
{
    QString message = "GET /counterclear1?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();        
}
// To reset the state of every counter we use this function
void clientDlg::onClearallCounter()
{
    QString message = "GET /counterclear?PW=" + le_password->text() + "&";
    client->writeBlock(message, message.length());
    client->flush();        
}
// All shots of the timer will be catched here
void clientDlg::timerEvent()
{    //In case of the specific timer we start the polling of outputs, inputs or counter
    if(output->isActive())	onReadallOutputs();
    if(input->isActive())	onReadallInputs();
    if(counter->isActive())	onReadallCounter();
}
// If an negativ value or an character has been typed display an message an don´t change the interval
bool clientDlg::checkRange()
{
    bool ok;
    int tmp = (le_interval->text()).toInt(&ok, 10);
    if(ok && tmp > 0)
    {
	le_statusBar->setText("Range changed to " + le_interval->text() + " ms!");
	return true;
    }	
    else
    {
	le_statusBar->setText("Please type a positiv integer value for the range of polling!");
	return false;
    }
}
// By check the checkbox cb_polling_outputs the polling on outputs begin
void clientDlg::onPollingOutputs()
{   
    if(checkRange())
    {	// By starting the timer, give him a range and let him periodic shot ( the second argument in the start 
	// routine of the timer)
	if(cb_polling_outputs->isChecked())
	    output->start((le_interval->text()).toInt(), false);
	else	// If the checkbox get unchecked, stop the specific timer 
	    output->stop();
    }
}
// Here we can define if polling on the inputs is active or disabled
void clientDlg::onPollingInputs()
{
    if(checkRange())
    {
	if(cb_polling_inputs->isChecked())
	    input->start((le_interval->text()).toInt(), false);
	else
	    input->stop();
    }
}
// To poll the counter we use this method
void clientDlg::onPollingCounter()
{
    if(checkRange())
    {
	if(cb_polling_counter->isChecked())
	    counter->start((le_interval->text()).toInt(), false);
	else
	    counter->stop();
    }
}
